//----------------------------|
// on-the-fly synchronization
// adapted from Perry's ChucK Drummin' + Ge's sine poops
//
// authors: Perry Cook (prc@cs.princeton.edu)
//          Ge Wang (gewang@cs.princeton.edu)
// --------------------|          
// add one by one into VM (in pretty much any order):
// 
// terminal-1%> chuck --loop
// ---
// terminal-2%> chuck + otf_01.ck
// (anytime later)
// terminal-2%> chuck + otf_02.ck
// (etc...)
//--------------------------------------|

// synchronize to period
.5::second => dur T;
T - (now % T) => now;

// connect patch
SinOsc s => dac;
.2 => s.gain;
 1 => int count;

// scale (pentatonic; in semitones) \
// This is the speend in scale. The speed is from 0 to 10, which maps the actual speed value from 0 to 1000
[ 0, 0, 0, 0,0, 2, 2, 2, 2, 2, 0, 0, 0, 0,0, 4, 4, 4, 4, 4, 7, 7, 7, 7, 7, 9, 9, 9, 9, 9,9, 9, 9, 9, 9 ] @=> int scale[];
scale.size() => int length;
// infinite time loop
while( true )
{
    <<<scale[count]>>>;
    (count + 1 )%length=> count;
    // pick something from the scale
    scale[ count] => float freq;
    // get the final freq    
    Std.mtof( 21.0 + (Std.rand2(0,3)*12 + freq) ) => s.freq;

    // advance time
    .25::T => now;
}